#ifndef __DEFINE_H__
#define __DEFINE_H__

// clang-format off
#define CONFIG_SIZE                 0x200  // 0x1f0
#define GL352X_21_CONFIG_SIZE       0x90
#define GL3523_CONFIG_SIZE          0x90
#define GL3590_CONFIG_SIZE          0x90

#define GLHUB_MAX_NUM               0x08

#define GLHUB_INI_FILE              "./GLHubIsp.ini"
#define GLHUB_SECTION               "GLHub"
#define HUB_SECTION                 "Hub"
#define HUB_1_SECTION               "Hub1"
#define HUB_2_SECTION               "Hub2"

#define BIN_FILE                    "BinFile"
#define EEP_FILE                    "EepFile"
#define ENUM_DELAY                  "Enum_Delay"
#define FLASHINFO_SECTION           "FlashInfo"
#define V_MergeConfig               "MergeConfig"
#define V_NumPorts                  "NumPorts"
#define V_PortIndicator             "PortIndicator"
#define V_EnableSString             "EnableSString"
#define V_NR_P1                     "NR_P1"
#define V_NR_P2                     "NR_P2"
#define V_NR_P3                     "NR_P3"
#define V_NR_P4                     "NR_P4"
#define V_C_P1                      "C_P1"
#define V_C_P2                      "C_P2"
#define V_C_P3                      "C_P3"
#define V_C_P4                      "C_P4"
#define V_Vid                       "VID"
#define V_Pid                       "PID"
#define V_SSPid                     "SSPID"
#define V_FWVer                     "FW_Version"
#define V_MaxPower                  "MaxPower"
#define V_SSMaxPower                "SS_MaxPower"
#define V_VString                   "VString"
#define V_HS_PString                "HS_PString"
#define V_SS_PString                "SS_PString"
#define V_SString                   "SString"
#define V_CmdDelay                  "CmdDelay"
#define V_EnumDelay                 "EnumDelay"
#define V_CUSTOMER                  "Customer"
#define V_ADVANCED                  "Advanced"
#define V_MULTI_MODE                "MultiMode"
#define V_EUSER_INSTALL_MODE        "EUserMode"
#define V_DRIVER_VERSION            "DriverVersion"
#define V_GL_HUB_TYPE               "GL_hub_type"
#define V_GL_HUB_VID                "VID"
#define V_GL_HUB_PID_HS             "PID_HS"
#define V_GL_HUB_PID_SS             "PID_SS"
#define V_SUPPORT_MULTINOUT         "SupportmultiINOUT"

#define GL352X_21_ROM_SIZE          0x5000
#define GL352X_21_EEPROM_SIZE       0x5000
#define GL3523_ROM_SIZE             0x6000
#define GL352X_21_EEPROM_SIZE_LITE  0x100

#define CHIP_ID_UNKNOWN             -1
#define CHIP_ID_GL352X_10_SPI       1
#define CHIP_ID_GL352X_21_SPI       2
#define CHIP_ID_GL352X_21_EEPROM    3
#define CHIP_ID_GL352X_21_EEPROM_LITE 4
#define CHIP_ID_GL3523_SPI          7
#define CHIP_ID_GL3523_EEPROM_LITE  8
#define CHIP_ID_GL3523_TYPE_C       9
#define CHIP_ID_GL3523_SUPPORT_QC   10
#define CHIP_ID_GL3590_SPI          11
#define CHIP_ID_GL3510_SPI          12
#define CHIP_ID_GL7000_SPI          13

#define DEFAULT_DRIVER_VERSION      "GLHC_Filter_Setup_V1.07"
#define GL3520_DEV_ID_0             "VID_05E3&PID_0610"
#define GL3520_DEV_ID_1             "VID_05E3&PID_0612"

#define GL352X_21_CHIP_ID_OFFSET    0x01D0
#define GL352X_21_CHECKSUN_OFFSET   0x4FFE
#define GL3523_CHECKSUN_OFFSET      0x5FFE
#define GL352X_21_EEP_CHECKSUN_OFFSET 0xFE
#define GL352X_21_EEPROM_ID_OFFSET  0x1C
#define GL352X_21_EEPROM_ID_STRING  "EROM"
#define GL352X_21_SPI_ID_STRING     "XROM"
#define GL352X_21_EEP_TRANSFER_LENGTH 64
#define GL352X_21_EEP_TRANSFER_LENGTH_LITE 8

#define BASE_ADDR_VSTRING           0x020
#define BASE_ADDR_HSPSTRING         0x0A0
#define BASE_ADDR_SSPSTRING         0x120
#define BASE_ADDR_SSTRING           0x1A0

#define GL_ISP_SW                   0x81
#define GL_ISP_READ                 0x82
#define GL_ISP_WRITE                0x83
#define GL_MP_SW                    0x91
#define GL_MP_READ                  0x92
#define GL_MP_WRITE                 0x93

#define EEP_ADDR_OFFSET             0x100
#define FW_VER_L_ADDR               0x10E
#define FW_VER_H_ADDR               0x10F
#define FW_VER_L_EEPROM             0x0E
#define FW_VER_H_EEPROM             0x0F

#define GL3520_CONTAINER_ID_OFFSET  0x36E
#define GL3521_CONTAINER_ID_OFFSET  0x1C0
#define GL3521_EEP_CONTAINER_ID_OFFSET 0x90
#define GL3510_CONTAINER_ID_OFFSET  0x1A4
#define GL3510_CONTAINER_ID_OFFSET_LONG_SERIALNUM 0x1B5  // shift for ID, +0x12

#define COMMAND_RETRY_TIMES         2
#define WORD_CONTAINER_ID_LENGTH    32
#define BYTE_CONTAINER_ID_LENGTH    16

#define TIMER_GL3520_EXISTED        1
#define TIMER_GL3520_NOT_EXISTED    2
#define ELAPSE_TIME_LONG            2000
#define ELAPSE_TIME_SHORT           200

#define MAX_KEY_LENGTH              255
#define MAX_VALUE_NAME              16383

#define CMD_TIMEOUT                 2000
#define USLEEP_TIME                 20000

#define MAX_CMD_LEN                 32
#define MAX_BUF_LEN                 256
#define VERSION                     "1.04"

#define FLASH_TYPE_NUMBER           0x100

#define LSUSB_FILE                  "gl_usb_list"
#define LSUSBT_FILE                 "usb_list_t"
#define GL_VID_STR                  "05e3"
#define GL_PID_U2_STR               "0610"
#define GL_PID_U3_STR               "0620"
#define MAX_CHAR_PER_LINE           1024

#define GL_VID                      0x05e3
#define GL_PID_U2                   0x0610
#define GL_PID_U3_1                 0x0612
#define GL_PID_U3_2                 0x0616
#define GL_PID_U3_3                 0x0620

#define GL3520_SS_PID_VALUE         0x0612
#define GL3521_SS_PID_VALUE         0x0616
#define GL3522_SS_PID_VALUE         0x0617

#define USBFS_ROOT "/dev/bus/usb"
// clang-format on

extern const char* errno_shortname[];
#endif /* __DEFINE_H__ */
